#include <avr/io.h>
#include <avr/interrupt.h>
#include "Defines.h"
#include "Timer0_Function_Prototypes.h"
#include "Key_Enum.h"

int main(void)
{
	InitPorts();
	InitTimer();
	sei();

	// No key is pressed at the beginning.
	KeyPressed keyPressed = None;;
	unsigned char debouncedStateE = 0xFF;
	unsigned char debouncedStateF = 0xFF;
	
	// Mode variables.
	bool inputMode = true;
	bool outputMode = false;

	while (inputMode)
	{
		debouncedStateE = GetDebouncedStateE();
		debouncedStateF = GetDebouncedStateF();

		// Process PortE then PortF.
		for (int i = 0; i < 8; i++)
		{
			if (!InputProcE(&keyPressed, debouncedStateE, i))
				break;
		}
		
		for (int i = 0; i < 8; i++)
		{
			if (!InputProcF(&keyPressed, debouncedStateF, i))
				break;
		}	
	}

	return 0;
}
